from dune.perftool.generation import (preamble,
                                      symbol,
                                      )
from dune.perftool.pdelab.quadrature import (name_quadrature_position,
                                             quadrature_preamble,
                                             )

@preamble
def define_geometry(name):
    return "auto {} = eg.geometry();".format(name)


@symbol
def name_geometry():
    define_geometry("geo")
    return "geo"


@symbol
def type_geometry():
    return 'EG'


@preamble
def define_dimension(name):
    geo = type_geometry()
    return 'auto {} = {}::Geometry::coorddimension;'.format(name, geo)


@symbol
def name_dimension():
    define_dimension("dim")
    return "dim"


def define_jacobian_inverse_transposed(name):
    geo = name_geometry()
    pos = name_quadrature_position()
    return quadrature_preamble("auto {} = {}.jacobianInverseTransposed({});".format(name,
                                                                                    geo,
                                                                                    pos,
                                                                                    )
                               )

@symbol
def name_jacobian_inverse_transposed():
    define_jacobian_inverse_transposed("J")
    return "J"
